Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.tree
Class DefaultTreeCellEditor

    java.lang.Object
      |
      +--javax.swing.tree.DefaultTreeCellEditor

All Implemented Interfaces:
  ActionListener, CellEditor, EventListener, TreeCellEditor, TreeSelectionListener

public class DefaultTreeCellEditor
extends Object
implements ActionListener, TreeCellEditor, TreeSelectionListener

A TreeCellEditor. You need to supply an instance of DefaultTreeCellRenderer so that the icons can be obtained. You can optionaly supply a TreeCellEditor that will be layed out according to the icon in the DefaultTreeCellRenderer. If you do not supply a TreeCellEditor, a TextField will be used. Editing is started on a triple mouse click, or after a click, pause, click and a delay of 1200 miliseconds.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `JTree`

Inner Class Summary
`class` | `DefaultTreeCellEditor.DefaultTextField` TextField used when no editor is supplied.
`class` | `DefaultTreeCellEditor.EditorContainer` Container responsible for placing the editingComponent.

Field Summary
`protected Color` | `borderSelectionColor` True if the border selection color should be drawn.
`protected boolean` | `canEdit` Should isCellEditable return true? This is set in configure...
`protected Component` | `editingComponent` Component used in editing, obtained from the editingContainer.
`protected Container` | `editingContainer` Editing container, will contain the editorComponent.
`protected Icon` | `editingIcon` Icon to use when editing.
`protected Font` | `font` Font to paint with, null indicates font of renderer is to be used.
`protected TreePath` | `lastPath` last path that was selected.
`protected int` | `lastRow` Row that was last passed into getTreeCellEditorComponent.
`protected int` | `offset` Used in editing.
`protected TreeCellEditor` | `realEditor` Editor handling the editing.
`protected DefaultTreeCellRenderer` | `renderer` Renderer, used to get border and offsets from.
`protected Timer` | `timer` Used before starting the editing session.
`protected JTree` | `tree` JTree instance listening too.

Constructor Summary
`DefaultTreeCellEditor(JTree tree, DefaultTreeCellRenderer renderer)` Constructs a DefaultTreeCellEditor object for a JTree using the specified renderer and a default editor.
`DefaultTreeCellEditor(JTree tree, DefaultTreeCellRenderer renderer, TreeCellEditor editor)` Constructs a DefaultTreeCellEditor object for a JTree using the specified renderer and the specified editor.

Method Summary
`void` | `actionPerformed(ActionEvent e)` Messaged when the timer fires, this will start the editing session.
`void` | `addCellEditorListener(CellEditorListener l)` Adds the CellEditorListener.
`void` | `cancelCellEditing()` Messages cancelCellEditing to the realEditor and removes it from this instance.
`protected boolean` | `canEditImmediately(EventObject event)` Returns true if `event` is null, or it is a MouseEvent with a click count > 2 and inHitRegion returns true.
`protected Container` | `createContainer()` Creates the container to manage placement of editingComponent.
`protected TreeCellEditor` | `createTreeCellEditor()` This is invoked if a TreeCellEditor is not supplied in the constructor.
`protected void` | `determineOffset(JTree tree, Object value, boolean isSelected, boolean expanded, boolean leaf, int row)`
`Color` | `getBorderSelectionColor()` Returns the color the border is drawn.
`Object` | `getCellEditorValue()` Returns the value currently being edited.
`Font` | `getFont()` Gets the font used for editing.
`Component` | `getTreeCellEditorComponent(JTree tree, Object value, boolean isSelected, boolean expanded, boolean leaf, int row)` Configures the editor.
`protected boolean` | `inHitRegion(int x, int y)` Should return true if the passed in location is a valid mouse location to start editing from.
`boolean` | `isCellEditable(EventObject event)` If the realEditor returns true to this message, prepareForEditing is messaged and true is returned.
`protected void` | `prepareForEditing()` Invoked just before editing is to start.
`void` | `removeCellEditorListener(CellEditorListener l)` Removes the previously added CellEditorListener l.
`void` | `setBorderSelectionColor(Color newColor)` Sets the color to use for the border.
`void` | `setFont(Font font)` Sets the font to edit with.
`protected void` | `setTree(JTree newTree)` Sets the tree currently editing for.
`boolean` | `shouldSelectCell(EventObject event)` Messages the realEditor for the return value.
`protected boolean` | `shouldStartEditingTimer(EventObject event)` Returns true if `event` is a MouseEvent and the click count is 1.
`protected void` | `startEditingTimer()` Starts the editing timer.
`boolean` | `stopCellEditing()` If the realEditor will allow editing to stop, the realEditor is removed and true is returned, otherwise false is returned.
`void` | `valueChanged(TreeSelectionEvent e)` Resets lastPath.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### realEditor

    protected TreeCellEditor realEditor

  Editor handling the editing.

### renderer

    protected DefaultTreeCellRenderer renderer

  Renderer, used to get border and offsets from.

### editingContainer

    protected Container editingContainer

  Editing container, will contain the editorComponent.

### editingComponent

    protected transient Component editingComponent

  Component used in editing, obtained from the editingContainer.

### canEdit

    protected boolean canEdit

  Should isCellEditable return true? This is set in configure... based on the path being edited and the selected selected path.

### offset

    protected transient int offset

  Used in editing. Indicates x position to place editingComponent.

### tree

    protected transient JTree tree

  JTree instance listening too.

### lastPath

    protected transient TreePath lastPath

  last path that was selected.

### timer

    protected transient Timer timer

  Used before starting the editing session.

### lastRow

    protected transient int lastRow

  Row that was last passed into getTreeCellEditorComponent.

### borderSelectionColor

    protected Color borderSelectionColor

  True if the border selection color should be drawn.

### editingIcon

    protected transient Icon editingIcon

  Icon to use when editing.

### font

    protected Font font

  Font to paint with, null indicates font of renderer is to be used.

Constructor Detail

### DefaultTreeCellEditor

    public DefaultTreeCellEditor(JTree tree,
                                 DefaultTreeCellRenderer renderer)

  Constructs a DefaultTreeCellEditor object for a JTree using the specified renderer and a default editor. (Use this constructor for normal editing.)
  Parameters:
    `tree` - a JTree object
    `renderer` - a DefaultTreeCellRenderer object

### DefaultTreeCellEditor

    public DefaultTreeCellEditor(JTree tree,
                                 DefaultTreeCellRenderer renderer,
                                 TreeCellEditor editor)

  Constructs a DefaultTreeCellEditor object for a JTree using the specified renderer and the specified editor. (Use this constructor for specialized editing.)
  Parameters:
    `tree` - a JTree object
    `renderer` - a DefaultTreeCellRenderer object
    `editor` - a TreeCellEditor object

Method Detail

### setBorderSelectionColor

    public void setBorderSelectionColor(Color newColor)

  Sets the color to use for the border.

### getBorderSelectionColor

    public Color getBorderSelectionColor()

  Returns the color the border is drawn.

### setFont

    public void setFont(Font font)

  Sets the font to edit with. null indicates the renderers font should be used. This will NOT override any font you have set in the editor the receiver was instantied with. If null for an editor was passed in a default editor will be created that will pick up this font.
  Parameters:
    `font` - the editing Font
  See Also:
    `getFont()`

### getFont

    public Font getFont()

  Gets the font used for editing.
  Returns:
    the editing Font
  See Also:
    `setFont(java.awt.Font)`

### getTreeCellEditorComponent

    public Component getTreeCellEditorComponent(JTree tree,
                                                Object value,
                                                boolean isSelected,
                                                boolean expanded,
                                                boolean leaf,
                                                int row)

  Configures the editor. Passed onto the realEditor.
  Specified by:
    `getTreeCellEditorComponent` in interface `TreeCellEditor`
  Following copied from interface: `javax.swing.tree.TreeCellEditor`
  Parameters:
    `table` - the JTree that is asking the editor to edit This parameter can be null.
    `value` - the value of the cell to be edited.
    `isSelected` - true is the cell is to be renderer with selection highlighting
    `expanded` - true if the node is expanded
    `leaf` - true if the node is a leaf node
    `row` - the row index of the node being edited
  Returns:
    the component for editing

### getCellEditorValue

    public Object getCellEditorValue()

  Returns the value currently being edited.
  Specified by:
    `getCellEditorValue` in interface `CellEditor`

### isCellEditable

    public boolean isCellEditable(EventObject event)

  If the realEditor returns true to this message, prepareForEditing is messaged and true is returned.
  Specified by:
    `isCellEditable` in interface `CellEditor`
  Following copied from interface: `javax.swing.CellEditor`
  Parameters:
    `anEvent` - the event the editor should use to consider whether to begin editing or not.
  Returns:
    true if editing can be started.
  See Also:
    `CellEditor.shouldSelectCell(java.util.EventObject)`

### shouldSelectCell

    public boolean shouldSelectCell(EventObject event)

  Messages the realEditor for the return value.
  Specified by:
    `shouldSelectCell` in interface `CellEditor`
  Following copied from interface: `javax.swing.CellEditor`
  Parameters:
    `anEvent` - the event the editor should use to start editing.
  Returns:
    true if the editor would like the editing cell to be selected
  See Also:
    `CellEditor.isCellEditable(java.util.EventObject)`

### stopCellEditing

    public boolean stopCellEditing()

  If the realEditor will allow editing to stop, the realEditor is removed and true is returned, otherwise false is returned.
  Specified by:
    `stopCellEditing` in interface `CellEditor`
  Following copied from interface: `javax.swing.CellEditor`
  Returns:
    true if editing was stopped

### cancelCellEditing

    public void cancelCellEditing()

  Messages cancelCellEditing to the realEditor and removes it from this instance.
  Specified by:
    `cancelCellEditing` in interface `CellEditor`

### addCellEditorListener

    public void addCellEditorListener(CellEditorListener l)

  Adds the CellEditorListener.
  Specified by:
    `addCellEditorListener` in interface `CellEditor`
  Following copied from interface: `javax.swing.CellEditor`
  Parameters:
    `l` - the CellEditorListener

### removeCellEditorListener

    public void removeCellEditorListener(CellEditorListener l)

  Removes the previously added CellEditorListener l.
  Specified by:
    `removeCellEditorListener` in interface `CellEditor`
  Following copied from interface: `javax.swing.CellEditor`
  Parameters:
    `l` - the CellEditorListener

### valueChanged

    public void valueChanged(TreeSelectionEvent e)

  Resets lastPath.
  Specified by:
    `valueChanged` in interface `TreeSelectionListener`
  Following copied from interface: `javax.swing.event.TreeSelectionListener`
  Parameters:
    `e` - the event that characterizes the change.

### actionPerformed

    public void actionPerformed(ActionEvent e)

  Messaged when the timer fires, this will start the editing session.
  Specified by:
    `actionPerformed` in interface `ActionListener`

### setTree

    protected void setTree(JTree newTree)

  Sets the tree currently editing for. This is needed to add a selection listener.

### shouldStartEditingTimer

    protected boolean shouldStartEditingTimer(EventObject event)

  Returns true if `event` is a MouseEvent and the click count is 1.

### startEditingTimer

    protected void startEditingTimer()

  Starts the editing timer.

### canEditImmediately

    protected boolean canEditImmediately(EventObject event)

  Returns true if `event` is null, or it is a MouseEvent with a click count > 2 and inHitRegion returns true.

### inHitRegion

    protected boolean inHitRegion(int x,
                                  int y)

  Should return true if the passed in location is a valid mouse location to start editing from. This is implemented to return false if `x` is <= the width of the icon and icon gap displayed by the renderer. In other words this returns true if the user clicks over the text part displayed by the renderer, and false otherwise.

### determineOffset

    protected void determineOffset(JTree tree,
                                   Object value,
                                   boolean isSelected,
                                   boolean expanded,
                                   boolean leaf,
                                   int row)

### prepareForEditing

    protected void prepareForEditing()

  Invoked just before editing is to start. Will add the `editingComponent` to the `editingContainer`.

### createContainer

    protected Container createContainer()

  Creates the container to manage placement of editingComponent.

### createTreeCellEditor

    protected TreeCellEditor createTreeCellEditor()

  This is invoked if a TreeCellEditor is not supplied in the constructor. It returns a TextField editor.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.